cbmk/build

128 lines
3.3 KiB
Plaintext
Raw Permalink Normal View History

#!/usr/bin/env sh
# SPDX-License-Identifier: GPL-3.0-or-later
# Copyright (c) 2020-2025 Leah Rowe <leah@libreboot.org>
# Copyright (c) 2022 Caleb La Grange <thonkpeasant@protonmail.com>
set -u -e
if [ "./${0##*/}" != "${0}" ] || [ ! -f "build" ] || [ -L "build" ]; then
printf "You must run this in the proper work directory.\n" 1>&2
exit 1
fi
. "include/lib.sh"
inject.sh: MAC address changer (not vendorfiles) This is based on include/vendor.sh from this lbmk revision: 3c9f4be76f61c80060b4238eff96ef268272cffb This version doesn't support downloading/injecting vendor files such as Intel ME; that's what the lbmk version is for. If you try to run this on a Libreboot archive that uses vendor files, the script will see that there is a hash file present, and not inject a new MAC. HOWEVER: if the hash file is not present, it will work just fine, but again only change the MAC. That way, you can use the "./mk inject" command from lbmk, to insert files such as Intel ME. In practise, due to the design checking out a specific cbfstool version based on the board config, you can only use a config in this way that's present on both Libreboot and Canoeboot, such as the E6400 images; the E6400 images on Libreboot insert an Nvidia GPU ROM, but Canoeboot does not. You don't need to run this on Libreboot tarballs, because the Libreboot version can be used anyway. Canoeboot is mostly a pointless project, but I maintain it for fun. I make it adhere to GNU FSDG for fun, even though I disagree with it; Libreboot's binary blob reduction policy is better. The reason for this design is because of GNU FSDG, which Canoeboot complies with to the letter. It states that any such project must not distribute, promote or otherwise boost proprietary software in any way; it must steer the user only towards entirely free software. It also doesn't support nuking. It only sets MAC addresses; the "setmac keep" command is not present, because it's pointless, but these work, e.g.: ./mk inject tarball.tar.xz ./mk inject tarball.tar.xz setmac ./mk inject tarball.tar.xz setmac restore ./mk inject tarball.tar.xz MACADDRESS ./mk inject tarball.tar.xz ??:aa:bb:??:22:01 etc Same command structure as setmac for lbmk. Signed-off-by: Leah Rowe <leah@libreboot.org>
2025-01-07 07:32:12 +00:00
. "include/inject.sh"
eval "`setvars "" vdir src_dirname srcdir mode xp ser`"
safer, simpler error handling in cbmk in shell scripts, a function named the same as a program included in the $PATH will override that program. for example, you could make a function called ls() and this would override the standand "ls". in cbmk, a part of it was first trying to run the "fail" command, deferring to "err", because some scripts call fail() which does some minor cleanup before calling err. in most cases, fail() is not defined, and it's possible that the user could have a program called "fail" in their $PATH, the behaviour of which we could not determine, and it could have disastrous effects. cbmk error handling has been re-engineered in such a way that the err function is defined in a variable, which defaults to err_ which calls err_, so defined under include/err.sh. in functions that require cleanup prior to error handling, a fail() function is still defined, and err is overridden, thus: err="fail" this change has made xx_() obsolete, so now only x_ is used. the x_ function is a wrapper that can be used to run a command and exit with non-zero status (from cbmk) if the command fails. the xx_ command did the same thing, but called fail() which would have called err(); now everything is $err example: rm -f "$filename" || err "could not delete file" this would now be: rm -f "$filename" || $err "could not delete file" overriding of err= must be done *after* including err.sh. for example: err="fail" . "include/err.sh" ^ this is wrong. instead, one must do: . "include/err.sh" err="fail" this is because err is set as a global variable under err.sh the new error handling is much cleaner, and safer. it also reduces the chance of mistakes such as: calling err when you meant to call fail. this is because the standard way is now to call $err, so you set err="fail" at the top of the script and all is well. Signed-off-by: Leah Rowe <info@minifree.org>
2024-03-27 01:19:39 +00:00
err="fail"
main()
{
[ $# -lt 1 ] && $err "bad command"
spath="script/$1"; shcmd="shift 1"
[ "${1#-*}" != "$1" ] && spath="script/trees" && shcmd=":"
for g in "command -v git" "git config --global user.name" \
"git config --global user.email" "git_init"; do
eval "$g 1>/dev/null 2>/dev/null || $err \"Unconfigured: $g\""
done
case "${spath#script/}" in
version) printf "%s\nWebsite: %s\n" "$relname" "$projectsite" ;;
inject.sh: MAC address changer (not vendorfiles) This is based on include/vendor.sh from this lbmk revision: 3c9f4be76f61c80060b4238eff96ef268272cffb This version doesn't support downloading/injecting vendor files such as Intel ME; that's what the lbmk version is for. If you try to run this on a Libreboot archive that uses vendor files, the script will see that there is a hash file present, and not inject a new MAC. HOWEVER: if the hash file is not present, it will work just fine, but again only change the MAC. That way, you can use the "./mk inject" command from lbmk, to insert files such as Intel ME. In practise, due to the design checking out a specific cbfstool version based on the board config, you can only use a config in this way that's present on both Libreboot and Canoeboot, such as the E6400 images; the E6400 images on Libreboot insert an Nvidia GPU ROM, but Canoeboot does not. You don't need to run this on Libreboot tarballs, because the Libreboot version can be used anyway. Canoeboot is mostly a pointless project, but I maintain it for fun. I make it adhere to GNU FSDG for fun, even though I disagree with it; Libreboot's binary blob reduction policy is better. The reason for this design is because of GNU FSDG, which Canoeboot complies with to the letter. It states that any such project must not distribute, promote or otherwise boost proprietary software in any way; it must steer the user only towards entirely free software. It also doesn't support nuking. It only sets MAC addresses; the "setmac keep" command is not present, because it's pointless, but these work, e.g.: ./mk inject tarball.tar.xz ./mk inject tarball.tar.xz setmac ./mk inject tarball.tar.xz setmac restore ./mk inject tarball.tar.xz MACADDRESS ./mk inject tarball.tar.xz ??:aa:bb:??:22:01 etc Same command structure as setmac for lbmk. Signed-off-by: Leah Rowe <leah@libreboot.org>
2025-01-07 07:32:12 +00:00
inject) shift 1; xbmk_inject "$@" ;;
release) shift 1; mkrelease "$@" ;;
roms)
[ $# -gt 1 ] && [ "$2" = "serprog" ] && \
mk -b stm32-vserprog pico-serprog && return 0
shift 1; x_ ./mk -b coreboot "$@" ;;
*)
[ -f "$spath" ] || $err "bad command"
$shcmd; "$spath" "$@" || $err "excmd: $spath $(echo "$@")" ;;
esac
}
git_init()
{
[ -L ".git" ] && return 1
[ -e ".git" ] && return 0
eval "`setvars "$(date -Rud @$versiondate)" cdate _nogit`"
git init || return 1
git add -A . || return 1
git commit -m "$projectname $version" --date "$cdate" \
--author="xbmk <xbmk@example.com>" || return 1
git tag -a "$version" -m "$projectname $version" || return 1
}
mkrelease()
{
export XBMK_RELEASE="y"
vdir="release"
while getopts d:m: option; do
[ -z "$OPTARG" ] && $err "empty argument not allowed"
case "$option" in
d) vdir="$OPTARG" ;;
m) mode="$OPTARG" ;;
*) $err "invalid option '-$option'" ;;
esac
done
vdir="$vdir/$version"
src_dirname="${relname}_src"
srcdir="$vdir/$src_dirname"
[ -e "$vdir" ] && $err "already exists: \"$vdir\""
mkdir -p "$vdir" || $err "mkvdir: !mkdir -p \"$vdir\""
git clone . "$srcdir" || $err "mkdir: !gitclone \"$srcdir\""
touch "$srcdir/lock" || $err "can't make lock file in $srcdir/"
build_release
printf "\n\nDONE! Check release files under %s\n" "$vdir"
}
build_release()
{
(
cd "$srcdir" || $err "$vdir: !cd \"$srcdir\""
./mk -f; x_ rm -Rf tmp; rmgit .
x_ mv src/docs docs
) || $err "can't create release files"
git log --graph --pretty=format:'%Cred%h%Creset %s %Creset' \
--abbrev-commit > "$srcdir/CHANGELOG" || $err "!gitlog $srcdir"
rm -f "$srcdir/lock" || $err "can't remove lock file in $srcdir"
(
cd "${srcdir%/*}" || $err "$vdir: mktarball \"$srcdir\""
mktarball "${srcdir##*/}" "${srcdir##*/}.tar.xz" || $err "$vdir: mksrc"
) || $err "can't create src tarball"
[ "$mode" = "src" ] && return 0
touch "$srcdir/lock" || $err "can't make lock file in $srcdir/"
(
cd "$srcdir" || $err "$vdir: 2 !cd \"$srcdir\""
mk -b coreboot pico-serprog stm32-vserprog pcsx-redux
x_ mv bin ../roms
) || $err "can't build rom images"
rm -Rf "$srcdir" || $err "!rm -Rf $srcdir"
}
fail()
{
tmp_cleanup || printf "WARNING: can't rm tmpfiles: %s\n" "$TMPDIR" 1>&2
safer, simpler error handling in cbmk in shell scripts, a function named the same as a program included in the $PATH will override that program. for example, you could make a function called ls() and this would override the standand "ls". in cbmk, a part of it was first trying to run the "fail" command, deferring to "err", because some scripts call fail() which does some minor cleanup before calling err. in most cases, fail() is not defined, and it's possible that the user could have a program called "fail" in their $PATH, the behaviour of which we could not determine, and it could have disastrous effects. cbmk error handling has been re-engineered in such a way that the err function is defined in a variable, which defaults to err_ which calls err_, so defined under include/err.sh. in functions that require cleanup prior to error handling, a fail() function is still defined, and err is overridden, thus: err="fail" this change has made xx_() obsolete, so now only x_ is used. the x_ function is a wrapper that can be used to run a command and exit with non-zero status (from cbmk) if the command fails. the xx_ command did the same thing, but called fail() which would have called err(); now everything is $err example: rm -f "$filename" || err "could not delete file" this would now be: rm -f "$filename" || $err "could not delete file" overriding of err= must be done *after* including err.sh. for example: err="fail" . "include/err.sh" ^ this is wrong. instead, one must do: . "include/err.sh" err="fail" this is because err is set as a global variable under err.sh the new error handling is much cleaner, and safer. it also reduces the chance of mistakes such as: calling err when you meant to call fail. this is because the standard way is now to call $err, so you set err="fail" at the top of the script and all is well. Signed-off-by: Leah Rowe <info@minifree.org>
2024-03-27 01:19:39 +00:00
err_ "${1}"
}
tmp_cleanup()
{
[ "$xbmk_parent" = "y" ] || return 0
[ "$TMPDIR" = "/tmp" ] || rm -Rf "$TMPDIR" || return 1
rm -f lock || return 1
}
main "$@"
tmp_cleanup || err_ "can't rm TMPDIR upon non-zero exit: $TMPDIR"